#include "public.h"
#include "common.h"
#include "audio.h"

int audio_fd;

int calcDMABUF()
{
    int power=0;
    int num;

    num=BUF_SIZE_BYTE;
    while(num>1)
    {
        num=num>>1;
        power++;
    }

    return (power);
}

void DSP_config()
{
    int format;
    int stereo;
    int samplerate;
    int dma_buffer_size;

    /*set full duplex*/
    /*
      if(ioctl(audio_fd, SNDCTL_DSP_SETDUPLEX,0)==-1)
      {
      perror("Error: SNDCTL_DSP_SETDUPLEX.");
      assert(false);
      }*/
    
    dma_buffer_size = DMA_BUF_NUM+calcDMABUF();
    if (ioctl(audio_fd, SNDCTL_DSP_SETFRAGMENT, &dma_buffer_size) == -1)
    {
        perror("Error: cannot set the DMA buffer.");
        assert(false);
    }

    /*set sample format*/
    /*
      format=FORMAT;
      if(ioctl(audio_fd, SNDCTL_DSP_SETFMT, &format) == -1)
      {
      perror("Error: SNDCTL_DSP_SETFMT.");
      assert(false);
      }
      
      if (format!=FORMAT)
      {
      perror("Error: the card doesn't support the format.");
      assert(false);
      }*/
    
    //set numbers of channels (mono or stereo)*
    
    /*
      stereo=STEREO;
      if (ioctl(audio_fd, SNDCTL_DSP_STEREO, &stereo)==-1)
      {
      perror("Error: SNDCTL_DSP_STEREO.");
      assert(false);
      }
      
      if (stereo!=STEREO)
      {
      perror("Error: the card doesn't support mono.");
      assert(false);
      }

    */
    /*set sampling rate*/
    samplerate=SAMPLERATE;
    if (ioctl(audio_fd, SNDCTL_DSP_SPEED, &samplerate)==-1)
    {
        perror("Error: SNDCTL_DSP_SPEED.");
        assert(false);
    }
    if (abs(samplerate-SAMPLERATE)>1000)
    {
        perror("Error:doesn't support the sampling rate");
        assert(false);
    }
}

void open_audio()
{
    if ((audio_fd = open(AUDIO, O_RDWR, 0)) == -1) 
    {
        close(audio_fd);
        if ((audio_fd = open(AUDIO, O_RDWR, 0)) == -1) 
            assert(false);
    }

    DSP_config();
}

void close_audio()
{
    close(audio_fd);
}
