#include "public.h"
#include "common.h"
#include "g72x.h"
#include "audio.h"

// include files for socket communication
#include <cstdio>
#include <cstdlib>
#include <unistd.h>
#include <cstring>
#include <errno.h>
#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/socket.h>

void main(int argc, char *argv[])
{
    unsigned char encodeBuf[COMP_SIZE];
    
    struct hostent *he;
    int s, conn_s, p_s;
    int datalen;
    struct sockaddr_in ls, rs;
    
    if((p_s = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
      perror("socket creation failed");
      exit(1);
    }
    
    if((s = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
      perror("socket creation failed");
      exit(1);
    }

    int maxseg=ECHO_MSS;
    if(setsockopt(s, 6, 2, (char *)&maxseg, sizeof(unsigned long)) == -1) {
      perror("setsockopt failed");
      exit(1);
    }
    if(setsockopt(p_s, 6, 2, (char *)&maxseg, sizeof(unsigned long)) == -1) {
      perror("setsockopt failed");
      exit(1);
    }
    
    int no_nagle=1;
    if(setsockopt(s, 6, 1, (char *)&no_nagle, sizeof(unsigned long)) == -1) {
      perror("setsockopt failed");
      exit(1);
    }
    
    if(setsockopt(p_s, 6, 1, (char *)&no_nagle, sizeof(unsigned long)) == -1) {
      perror("setsockopt failed");
      exit(1);
    }
    
    bzero(&ls, sizeof(struct sockaddr_in));
    bzero(&rs, sizeof(struct sockaddr_in));
   
    ls.sin_family = AF_INET;
    ls.sin_port = htons(rPORT);
    inet_aton(ADDR_SnR, (struct in_addr *)&ls.sin_addr);

    rs.sin_family = AF_INET;
    rs.sin_port = htons(pPORT);
    inet_aton(ADDR_P, (struct in_addr *)&rs.sin_addr);
    //bind
    if(bind(s, (struct sockaddr *)&ls, sizeof(struct sockaddr_in)) == -1) {
      perror("bind failed: ");
      exit(1);
    }
    
    if(connect(p_s, (struct sockaddr *)&rs, sizeof(struct sockaddr_in)) == -1){
      perror("connect failed: ");
      exit(2);
    }
    
    //listen and accept a connect
    if(listen(s, 5) == -1){
      perror("listen: ");
      exit(2);
    }
    
    int ln=sizeof(struct sockaddr_in);
    if((conn_s=accept(s, (struct sockaddr *)&ls, (socklen_t *)&ln)) == -1){
      perror("accept: ");
      exit(3);
    }

    if(setsockopt(conn_s, 6, 1, (char *)&no_nagle, sizeof(unsigned long)) == -1) {
      perror("setsockopt failed");
      exit(1);
    }
    if(setsockopt(conn_s, 6, 2, (char *)&maxseg, sizeof(unsigned long)) == -1) {
      perror("setsockopt failed");
      exit(1);
    }
    if(TCP_BOTH){
	      if(argc < 2){
		  	printf("Command line argument for remote udp echo server needed\n");
		    	exit(3);
		      }
            if((he = gethostbyname(argv[1])) == NULL) {
      	perror("gethostbyname failed");
      exit(1);
      } 
            if(setsockopt(conn_s, 6, 13, he->h_addr, he->h_length) == -1) {
		perror("setsockopt failed");
    	exit(1);
      }
        }
     
    int i=0;
    while(1)
    {
      for(int datalen=0, fraglen=0; datalen<COMP_SIZE; ){
	if((fraglen=recv(conn_s, encodeBuf+datalen, COMP_SIZE - datalen, 0)) == -1){
	  perror("recv: ");
	  exit(4);
	}
	datalen+=fraglen;
      }
      
      if(send(p_s, encodeBuf, COMP_SIZE, 0) <COMP_SIZE){
	    perror("Forward: ");
	    exit(3);
      }
      
      printf ("Packet forwarded: %d\n", i++);
    }
}
